<template>
  <svg :width="width" :height="height" class="barChart"> 
    <g class="yGridLines" ref="yGridLines" 
      :transform="`translate(${margin.left}, 0)`"/>
    <rect v-for="bar in bars" 
      :key="bar.id" 
      :y="bar.y" 
      :x="bar.x" 
      :height="bar.height" 
      :width="bar.width" 
      :fill="bar.fill" 
      :data="bar.data"
    />
    <g class="yAxis" ref="yAxis" 
      :transform="`translate(${margin.left}, 0)`"/>
    <g class="xAxis" ref="xAxis" 
      :transform="`translate(0, ${height - margin.bottom})`" />
  </svg >
</template>

<script>
import * as d3 from 'd3' 
import {TweenMax} from 'gsap'

export default {
  props: ['data'],
  data () {
    return {
      width: 850,
      height: 250,
      margin: { top: 25, right: 20, bottom: 25, left: 35 },
      bars: [],
    }
  },

  methods: {
    renderAxes () {
      const xAxis = d3.axisBottom().scale(this.xScale).ticks(9)
              .tickFormat(d3.timeFormat("%b %y"))
      const yAxis = d3.axisLeft().scale(this.yScale).tickFormat(d => `${d}°C`)
      const yGridLines = d3.axisLeft().scale(this.yScale)
              .tickSize(-1 * (this.width - (this.margin.left + this.margin.right)) , 0, 0)
              .tickFormat('')
      d3.select(this.$refs.xAxis).call(xAxis)
      d3.select(this.$refs.yAxis).call(yAxis)
      d3.select(this.$refs.yGridLines).call(yGridLines)
    },

    calcScales () {
      const extentDate = d3.extent(this.data, d => d.date)
      const colorExtent = d3.extent(this.data, d => d.avg).reverse()
      this.colorScale = d3.scaleSequential()
        .domain(colorExtent)
        .interpolator(d3.interpolateRdYlBu)
 
      this.xScale = d3.scaleTime()
        .domain(extentDate)
        .range([this.margin.left, this.width - this.margin.right])

      this.yScale = d3.scaleLinear()
        .domain([-15, 40])
        .range([this.height - this.margin.bottom, this.margin.top])
     },

     calcBars() {
      const barWidth =  this.width / this.data.length - 1
      this.bars = this.data.map((d, i) => { 
        return {
          x: this.xScale(d.date),
          y: this.bars[i] ? this.bars[i].y : this.yScale(0),
          newY: this.yScale(d.high),
          newHeight: this.yScale(d.low) - this.yScale(d.high),
          width: barWidth,
          height: this.bars[i] ? this.bars[i].height : 0, 
          fill: this.colorScale(d.avg),
          data: `${d.date}`,
        }
      })
    },

    animate () {
      TweenMax.staggerFromTo(this.bars, 0.75, {
        // from
        cycle: {
          y: (i) => this.bars[i].y,
          height: (i) => this.bars[i].height,
        }
      }, {
        // to
        cycle: {
          y: (i) => this.bars[i].newY,
          height: (i) => this.bars[i].newHeight,
        },
      })
    },
  },
  watch: {
    data () {
     this.calcScales()
     this.renderAxes()
     this.calcBars()
     this.animate()
    },
  },
}
</script>

<style>
body {
  background: #383c4a;
}

.xAxis line, .yAxis line {
  stroke: #ccc;
}

.xAxis path, .yAxis path {
  stroke: #ccc;
}

.xAxis text, .yAxis text {
  color: #ccc;
}

.yAxis path, .yGridLines path {
  stroke: none;
}

.yGridLines line {
  stroke: #ccc;
  stroke-width: 1px;
  stroke-opacity: .2;
}

.barChart {
  border: #ccc 0px solid;
}

#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
